#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mem.h>
#include <dir.h>
#include <unistd.h>

#define FALSE 0
#define TRUE -1

char all_dir[25][80]; // [level] [chars]


int nb_layer(FILE * in, int nb_char)
{
   long first_pos, nbo, nbp, tmp[10], n2, i, n;
   int  nbl, l, c, reto, retp, reto2, retz;

   first_pos = ftell(in);
   for (nbl=1; nbl<20; nbl++)
   {
//fprintf(stderr, "trying %i layers\n", nbl);
      fseek(in, first_pos, SEEK_SET);

      // layers
      c = 1;
      for (l=0; l<nbl && c != EOF; l++)
      {
//fprintf(stderr, "   reading layer %i (%08lX)\n", l, ftell(in));
         for (i=0; i<nb_char && c != EOF; i++)
            c = fgetc(in);
      }

      // objects
      reto = fread(&nbo, 4, 1, in);
      if (reto == 1)
      {
//fprintf(stderr, "   trying %li objects\n", nbo);
         reto2 = 5;
         for (i=0; i<nbo && reto2 == 5; i++)
            reto2 = fread(&tmp, 4, 5, in);

         // paths
         retp = fread(&nbp, 4, 1, in);
         if (retp == 1)
         {
//fprintf(stderr, "      trying %li paths\n", nbp);
            retz = 3;
            for (i=0; i<nbp && retz == 3; i++)
            {
               fread(&n2,  4, 1, in);
//fprintf(stderr, "         path %li : trying %li sub_paths\n", i, n2);
               fread(&tmp, 4, 2, in);
               if (n2 > 0)
                  retz = 3;
               else
                  retz = 0;
               for (n=0; n<n2 && retz == 3; n++)
                  retz = fread(&tmp, 4, 3, in);
            }
            if (retz == 3) // not yet eof
            {
               c = fgetc(in);
               if (c == EOF)
               {
                  // ok, found nb layer
//fprintf(stderr, "      found EOF after just paths\n", nbp);
                  fseek(in, first_pos, SEEK_SET);
                  return nbl;
               }
            }
         }
      }
   }
   fseek(in, first_pos, SEEK_SET);
   return 0;
}


void info_ds1(char * filename)
{
   FILE * in;
   long w, h, x1, act, x2, x3, x4, f, i, n, p, old_pos, temp;
   int  c, x, y, maxlayer, done, all_zero;
   int  temp_curlay = 0;

   in = fopen(filename, "rb");
   if (in == NULL)
   {
      printf("\tcan't open %s", filename);
      return;
   }
fprintf(stderr, "checking %s\n", filename);
   fread(&x1, 1, 4, in);
   printf("\t%li", x1);
   fread(&w, 1, 4, in);
   printf("\t%li", w+1);
   fread(&h, 1, 4, in);
   printf("\t%li\t%li", h+1, (w+1) * (h+1));

   act = x2 = x3 = x4 = 0;
   
   if (x1 != 3)
   {
      fread(&act, 1, 4, in);
      printf("\t%li", act+1);
   }
   else
      printf("\t");
      
   if ((x1 != 3) && (x1 != 8))
   {
      fread(&x2, 1, 4, in);
      printf("\t%li", x2);
   }
   else
      printf("\t");
      
   fread(&f, 1, 4, in);
   printf("\t%li", f);
   for (i=0; i<24; i++)
   {
      printf("\t");
      if (i<f)
      {
         c = fgetc(in);
         while (c != 0)
         {
            printf("%c", c > 32 ? c : "#");
            c = fgetc(in);
         }
      }
   }

   if ((x1 != 3) && (x1 != 8))
   {
      fread(&x3, 1, 4, in);
      printf("\t%li", x3);
      fread(&x4, 1, 4, in);
      printf("\t%li", x4);
   }
   else
      printf("\t\t");

   maxlayer = nb_layer(in, 4 * ((w+1) * (h+1)));
   if (maxlayer == 0)
   {
      maxlayer = 1 + x2 + (x3 * 2) + x4;
fprintf(stderr, "NEW maxlayer = %i\n", maxlayer);
   }


if (x2)
   maxlayer = 2 + 2*x3 + x4;
else
   maxlayer = 1 + 2*x3 + x4;
   

   if ((x1 == 3) || (x1 == 8))
      maxlayer = 6;

   if (x1==12)
      maxlayer = 6;

   if (x1==13)
      maxlayer = 7;

   printf("\t%li", maxlayer);
   fflush(stdout);

   if (x3 != 5000)
   {
      printf("\t");
      for (i=0; i < 12; i++)
      {
         if (i<maxlayer)
         {
            printf("\t%li", ftell(in));
            fflush(stdout);
            for (y=0; y<h+1; y++)
            {
               for (x=0; x<w+1; x++)
               {
                  fread(&n, 1, 4, in);
//               printf(" %08lX", n);
               }
            }
         }
         else
           printf("\t");
      }
   }
   else
   {
      fread( & temp, 1, 4, in);
      printf("\t%li", temp);
      fflush(stdout);
      
      // walls layers (variable amount)
      for (i=0; i < (temp * 2) + (x2 ? 3 : 0); i++)
      {
         temp_curlay++;
         printf("\t%li", ftell(in));
         fflush(stdout);
         for (y=0; y<h+1; y++)
         {
            for (x=0; x<w+1; x++)
            {
               if (fread(&n, 1, 4, in) < 4)
               {
                  i = 500;
                  y = h+1;
                  x = w+1;
               }
            }
         }
         if (x2 && i == 1)
            fread( & temp, 1, 4, in);
      }

      
      // floors layers (variable amount)
      for (i=0; i < 1; i++)
      {
         temp_curlay++;
         printf("\t%li", ftell(in));
         fflush(stdout);
         for (y=0; y<h+1; y++)
         {
            for (x=0; x<w+1; x++)
            {
               if (fread(&n, 1, 4, in) < 4)
               {
                  i = maxlayer;
                  y = h+1;
                  x = w+1;
                  done = TRUE;
               }
            }
         }
      }

      // NULL layer
      for (i=0; i < 1; i++)
      {
         temp_curlay++;
         printf("\t%li", ftell(in));
         fflush(stdout);
         for (y=0; y<h+1; y++)
         {
            for (x=0; x<w+1; x++)
            {
               if (fread(&n, 1, 4, in) < 4)
               {
                  i = 10;
                  y = h+1;
                  x = w+1;
                  done = TRUE;
               }
            }
         }
      }

      for (i=temp_curlay; i< 12; i++)
         printf("\t");
   }

   printf("\t%li", ftell(in));
   fread(&n, 1, 4, in);
   printf("\t%li", n);
   if (n>181)
      n = 181;
   for (i=0; i<n; i++)
   {
      fread(&p, 1, 4, in);
      printf("\t%02lX", p);
      fread(&p, 1, 4, in);
      printf(" - %02lX", p);
      fread(&p, 1, 4, in);
      printf(" - %02lX", p);
      fread(&p, 1, 4, in);
      printf(" - %02lX", p);
      fread(&p, 1, 4, in);
      printf(" - %02lX", p);
   }
//   printf("\n\n");
   fclose(in);
}


int check_for_ds1(int level)
{
   struct ffblk f;
   int          done, i;

   done = findfirst("*.ds1", &f, FA_ARCH);
   while ( ! done)
   {
      for (i=0; i<level; i++)
         printf("%s\\", all_dir[i]);
      printf("%s", f.ff_name);
      info_ds1(f.ff_name);
      printf("\n", f.ff_name);
      done = findnext(&f);
   }

}

int check_for_dir(int level)
{
   struct ffblk f;
   int          done, i;

   if (level > 25)
      return;
   done = findfirst("*.*", &f, FA_DIREC);
   while ( ! done)
   {
      if (f.ff_name[0] != '.' && (f.ff_attrib & FA_DIREC))
      {
         strcpy(all_dir[level], f.ff_name);
         chdir(f.ff_name);
         check_for_dir(level + 1);
      }
      done = findnext(&f);
   }
   check_for_ds1(level);
   chdir("..");
}

int main(int argc, char * argv[])
{
   int i;
   
   freopen("all_ds1.txt", "wt", stdout);
   printf("file\tx1\twidth\theight\t(total)\tact\tx2\t!wall!\t#file\tfile1\tfile2\tfile3\tfile4\tfile5\tfile6\tfile7\tfile8\tfile9\tfile10\tfile11\tfile12\tfile13\tfile14\tfile15\tfile16\tfile17\tfile18\tfile19\tfile20\tfile21\tfile22\tfile23\tfile24\tx3\tx4\tnum_layer\tlayer1_offset\tlayer2_offset\tlayer3_offset\tlayer4_offset\tlayer5_offset\tlayer6_offset\tlayer7_offset\tlayer8_offset\tlayer9_offset\tlayer10_offset\tlayer11_offset\tlayer12_offset\tobject_offset\t#objects");
   for (i=0; i<181; i++)
      printf("\tobj%i_props", i);
   printf("\n");
   chdir("d:\\");
   check_for_dir(0);
   check_for_ds1(0);
   chdir("c:");
}

