#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mem.h>
#include <dir.h>
#include <unistd.h>

#define FALSE 0
#define TRUE -1

char all_dir[25][80]; // [level] [chars]

struct
{
   unsigned char prop1;
   unsigned char prop2;
   unsigned char prop3;
   unsigned char prop4;
   unsigned char orientation;
   unsigned char z1;
   unsigned char z2;
   unsigned char z3;
} layer[4][256][256];

void info_ds1(char * filename)
{
   FILE * in;
   long w, h, x1, act, x2, x3, x4, f, i, n, p, old_pos;
   int  c, x, y, maxlayer, done, all_zero, nb = 0;

   in = fopen(filename, "rb");
   if (in == NULL)
   {
      printf("\tcan't open %s", filename);
      return;
   }
fprintf(stderr, "checking %s", filename);
   fread(&x1, 1, 4, in);

if (x1 < 15)
{
   printf("\t<15\n");
   fclose(in);
   return;
}

   fread(&w, 1, 4, in);
   fread(&h, 1, 4, in);

   act = x2 = x3 = x4 = 0;
   
   if (x1 != 3)
      fread(&act, 1, 4, in);
      
   if ((x1 != 3) && (x1 != 8))
      fread(&x2, 1, 4, in);
      
   fread(&f, 1, 4, in);
   for (i=0; i<24; i++)
   {
      if (i<f)
      {
         c = fgetc(in);
         while (c != 0)
            c = fgetc(in);
      }
   }

   if ((x1 != 3) && (x1 != 8))
   {
      fread(&x3, 1, 4, in);
      fread(&x4, 1, 4, in);
   }

   maxlayer = 1 + (x3 * 2) + x4;
   if (x2)
      maxlayer++;


   if ((x1 == 3) || (x1 == 8))
      maxlayer = 6;

   if (x1==12)
      maxlayer = 6;

   if (x1==13)
      maxlayer = 7;

   for (i=0; i < x3; i++)
   {
      for (y=0; y<h+1; y++)
      {
         for (x=0; x<w+1; x++)
         {
            fread(&layer[i][y][x].prop1, 1, 1, in);
            fread(&layer[i][y][x].prop2, 1, 1, in);
            fread(&layer[i][y][x].prop3, 1, 1, in);
            fread(&layer[i][y][x].prop4, 1, 1, in);
         }
      }
      for (y=0; y<h+1; y++)
      {
         for (x=0; x<w+1; x++)
         {
            fread(&layer[i][y][x].orientation, 1, 1, in);
            fread(&layer[i][y][x].z1, 1, 1, in);
            fread(&layer[i][y][x].z2, 1, 1, in);
            fread(&layer[i][y][x].z3, 1, 1, in);
         }
      }
      for (y=0; y<h+1; y++)
      {
         for (x=0; x<w+1; x++)
         {
            if (layer[i][y][x].orientation == 10)
            {
               printf("\t%i\t%i\t%i\t%i\n",
                  layer[i][y][x].prop1,
                  layer[i][y][x].prop2,
                  layer[i][y][x].prop3,
                  layer[i][y][x].prop4
               );
               nb++;
            }
         }
      }
   }

   // end
if (nb == 0)
   printf("\n");

   fprintf(stderr, "\n");
   fclose(in);
}


int check_for_ds1(int level)
{
   struct ffblk f;
   int          done, i;

   done = findfirst("*.ds1", &f, FA_ARCH);
   while ( ! done)
   {
      for (i=0; i<level; i++)
         printf("%s\\", all_dir[i]);
      printf("%s", f.ff_name);
      info_ds1(f.ff_name);
      done = findnext(&f);
   }

}

int check_for_dir(int level)
{
   struct ffblk f;
   int          done, i;

   if (level > 25)
      return;
   done = findfirst("*.*", &f, FA_DIREC);
   while ( ! done)
   {
      if (f.ff_name[0] != '.' && (f.ff_attrib & FA_DIREC))
      {
         strcpy(all_dir[level], f.ff_name);
         chdir(f.ff_name);
         check_for_dir(level + 1);
      }
      done = findnext(&f);
   }
   check_for_ds1(level);
   chdir("..");
}

int main(int argc, char * argv[])
{
   int i;
   
   freopen("all_ds1.txt", "wt", stdout);
   chdir("d:\\");
   check_for_dir(0);
   check_for_ds1(0);
   chdir("c:");
}

