#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mem.h>

#define FALSE 0
#define TRUE -1

/*
int nb_layer(FILE * in, int nb_char)
{
   long first_pos, nbo, nbp, tmp[10], n2, i, n;
   int  nbl, l, c, reto, retp, reto2, retz;

   first_pos = ftell(in);
   for (nbl=1; nbl<20; nbl++)
   {
fprintf(stderr, "trying %i layers\n", nbl);
      fseek(in, first_pos, SEEK_SET);

      // layers
      c = 1;
      for (l=0; l<nbl && c != EOF; l++)
      {
fprintf(stderr, "   reading layer %i (%08lX)\n", l, ftell(in));
         for (i=0; i<nb_char && c != EOF; i++)
            c = fgetc(in);
      }

      // objects
      reto = fread(&nbo, 4, 1, in);
      if (reto == 1)
      {
fprintf(stderr, "   trying %li objects\n", nbo);
         reto2 = 5;
         for (i=0; i<nbo && reto2 == 5; i++)
            reto2 = fread(&tmp, 4, 5, in);

         // paths
         retp = fread(&nbp, 4, 1, in);
         if (retp == 1)
         {
fprintf(stderr, "      trying %li paths\n", nbp);
            retz = 3;
            for (i=0; i<nbp && retz == 3; i++)
            {
               fread(&n2,  4, 1, in);
fprintf(stderr, "         path %li : trying %li sub_paths\n", i, n2);
               fread(&tmp, 4, 2, in);
               if (n2 > 0)
                  retz = 3;
               else
                  retz = 0;
               for (n=0; n<n2 && retz == 3; n++)
                  retz = fread(&tmp, 4, 3, in);
            }
            if (retz == 3) // not yet eof
            {
               c = fgetc(in);
               if (c == EOF)
               {
                  // ok, found nb layer
fprintf(stderr, "      found EOF after just paths\n", nbp);
                  fseek(in, first_pos, SEEK_SET);
                  return nbl;
               }
            }
         }
      }
   }
   fseek(in, first_pos, SEEK_SET);
   return 0;
}
*/

int main(int argc, char * argv[])
{
   FILE * in;
   long w, h, x1, act, x2, x3, x4, f, i, i2, n, n2, p, old_pos;
   int  c, x, y, maxlayer, done, all_zero;

   if (argc == 1)
   {
      printf("Syntaxe : ds1info <file.ds1>\n");
      exit(0);
   }
   in = fopen(argv[1], "rb");
   if (in == NULL)
   {
      printf("can't open %s\n", argv[1]);
      exit(1);
   }
   printf("=======================\n%s\n=======================\n", argv[1]);
   fread(&x1, 1, 4, in);
   printf("x1     = %li\n", x1);
   fread(&w, 1, 4, in);
   printf("width  = %li (+1 = %li)\n", w, w+1);
   fread(&h, 1, 4, in);
   printf("height = %li (+1 = %li)\n", h, h+1);

   if (x1 != 3)
   {
      fread(&act, 1, 4, in);
      printf("act    = %li ( = act %li)\n", act, act+1);
   }
   else
      printf("no act data (x1 = 3)\n");


   if ((x1 != 3) && (x1 != 8))
   {
      fread(&x2, 1, 4, in);
      printf("x2     = %li", x2);
      if (x2)
         printf(" (optional layer, type %li)", x2);
      else
         printf(" (optional layer, not present)");
      printf("\n");
   }
   else
      printf("no x2 data (x1 = %i)\n", x1);

   fread(&f, 1, 4, in);
   printf("files  = %li\n", f);
   for (i=0; i<f; i++)
   {
      printf("   file %li = ", i);
      c = fgetc(in);
      while (c != 0)
      {
         printf("%c", c > 32 ? c : 32);
         c = fgetc(in);
      }
      printf("\n");
   }

   if ((x1 != 3) && (x1 != 8))
   {
      fread(&x3, 1, 4, in);
      printf("x3     = %li (wall layers)\n", x3);
      fread(&x4, 1, 4, in);
      printf("x4     = %li (floor layers)\n", x4);
   }
   else
   {
      printf("no x3 & no x4 data (x1 = %i)\n", x1);
   }

   // search the number of layers

   maxlayer = 1 + (x3 * 2) + x4;
   if (x2)
      maxlayer++;

//   maxlayer = nb_layer(in, 4 * ((w+1) * (h+1)));



   if ((x1 == 3) || (x1 == 8) || (x1 == 12))
      maxlayer = 6;

   if (x1==13)
      maxlayer = 7;

//maxlayer = 5;

printf("\nMAX_LAYERS = %li  (2 * %li walls + %li floors + 1 shadows%s)\n",
   maxlayer, x3, x4, x2 ? " + 1 optional layer" : "");

   if (x3 != 5000)
   {
      for (i=0; i < maxlayer; i++)
      {
         printf("\nlayer %i (offset %08lX)\n", i, ftell(in));
         for (y=0; y<h+1; y++)
         {
            for (x=0; x<w+1; x++)
            {
               if (fread(&n, 1, 4, in) < 4)
               {
                  i = maxlayer;
                  y = h+1;
                  x = w+1;
                  printf("\nstop : EOF\n");
               }
               else
                  printf(" %08lX", n);
            }
            printf("\n");
         }
         printf("\n");
      }
   }
   else
   {
      fread(&maxlayer, 1, 4, in);
      printf("\nreading 4 bytes... nb_layer = %li\n", maxlayer);
      
      // walls layers (variable amount)
      for (i=0; i < (maxlayer * 2) + (x2 ? 3 : 0); i++)
      {
         printf("\nWALL layer %i (offset %08lX)\n", i, ftell(in));
         for (y=0; y<h+1; y++)
         {
            for (x=0; x<w+1; x++)
            {
               if (fread(&n, 1, 4, in) < 4)
               {
                  i = maxlayer;
                  y = h+1;
                  x = w+1;
               }
               else
                  printf(" %08lX", n);
            }
            printf("\n");
         }
         printf("\n");
         if (x2 && i == 1)
         {
            fread(&maxlayer, 1, 4, in);
            printf("\nreading 4 bytes... nb_layer = %li\n", maxlayer);
         }
      }

      
      // floors layers (variable amount)
      for (i=0; i < 1; i++)
      {
         printf("\nFLOOR layer %i (offset %08lX)\n", i, ftell(in));
         for (y=0; y<h+1; y++)
         {
            for (x=0; x<w+1; x++)
            {
               if (fread(&n, 1, 4, in) < 4)
               {
                  i = maxlayer;
                  y = h+1;
                  x = w+1;
                  done = TRUE;
               }
               else
                  printf(" %08lX", n);
            }
            printf("\n");
         }
         printf("\n");
      }

/*
      // optional layer
      for (i=0; i < x2 ? 1 : 0; i++)
      {
         printf("\nOptional layer (x2 = %li) (offset %08lX)\n", x2, ftell(in));
         for (y=0; y<h+1; y++)
         {
            for (x=0; x<w+1; x++)
            {
               if (fread(&n, 1, 4, in) < 4)
               {
                  i = maxlayer;
                  y = h+1;
                  x = w+1;
                  done = TRUE;
               }
               else
                  printf(" %08lX", n);
            }
            printf("\n");
         }
         printf("\n");
      }
*/
      // SHADOW layer
      for (i=0; i < 1; i++)
      {
         printf("\nSHADOW layer (offset %08lX)\n", ftell(in));
         for (y=0; y<h+1; y++)
         {
            for (x=0; x<w+1; x++)
            {
               if (fread(&n, 1, 4, in) < 4)
               {
                  i = 10;
                  y = h+1;
                  x = w+1;
                  done = TRUE;
               }
               else
                  printf(" %08lX", n);
            }
            printf("\n");
         }
         printf("\n");
      }
   }

   printf("%08lX : objects = ", ftell(in));
   if (fread(&n, 4, 1, in) == 1)
   {
      printf("%li (%s)\n", n, n ? "some objets" : "no objects");
      printf("   Num     Type       Id        X        Y      Zero\n");
      printf("   --- -------- -------- -------- --------  --------\n");
   }
   else
      printf("no data of objects at all\n");
   
   if (n>300)
      n = 300;
   for (i=0; i<n; i++)
   {
      printf("   %3i", i);

      fread(&p, 1, 4, in);
      printf(" %8li", p);
      fread(&p, 1, 4, in);
      printf(" %8li", p);
      fread(&p, 1, 4, in);
      printf(" %8li", p);
      fread(&p, 1, 4, in);
      printf(" %8li", p);
      fread(&p, 1, 4, in);
      printf(" %8li\n", p);
   }
   printf("\n");

   // until eof

// /*
   c = fread(&n, 1, 4, in);
   if (c == 4)
   {
      printf("%08lX : %li NPC paths\n", ftell(in), n);
      for (i=0; i<n; i++)
      {
         fread(&n2, 1, 4, in);
         printf("\nnpc %i : %li paths, object at coord (", i, n2);

         fread(&p, 1, 4, in);
         printf("%li, ", p);
         fread(&p, 1, 4, in);
         printf("%li) [%08lX]\n", p, ftell(in));

         printf("   Num        X        Y   Action\n");
         printf("   --- -------- -------- --------\n");
         for (i2=0; i2<n2; i2++)
         {
            printf("   %3i", i2);

            fread(&p, 1, 4, in);
            printf(" %8li", p);
            fread(&p, 1, 4, in);
            printf(" %8li", p);
            fread(&p, 1, 4, in);
            printf(" %8li\n", p);
         }
      }
   }
   else
      printf("no NPC paths at all\n");
// */

   // unknown data (when x2 = 1)
   c = fread(&n2, 1, 4, in);
   i = x = 0;
   if (c == 4)
   {
      printf("%08lX : ", ftell(in));
      printf("%li unknown structure data :\n", n2);
      printf("   %3i : ", i);
      while ((c == 4) && (i < n2))
      {
         c = fread(&n, 1, 4, in);
         if (c == 4)
         {
            printf(" %08X", n);
            x++;
            if (x == 5)
            {
               x = 0;
               i++;
               printf("\n");
               if (i < n2)
                  printf("   %3i : ", i);
            }
         }
      }
      if ((c>0) && (c != 4))
         printf("\n(%08X)\n", n);
   }
      
   // until eof
   c = fread(&n, 1, 4, in);
   if (c == 4)
   {
      printf("\n%08lX : unknown datas\n", ftell(in));
      while (c == 4)
      {
         printf("%08X\n", n);
         c = fread(&n, 1, 4, in);
      }
   }
   if ((c>0) && (c != 4))
      printf("\n(%08X)\n", n);
      
   fclose(in);
}

